#include "LifeGameData.hpp"


/*
LifeGamẽf[^\
t@CɏoƂ́A
name\twidth\theight\t110001011...
ƂBname͕Awidth,height ͐̐B
̌̐1sڂ珇ɃCt݂邩ǂ01ŏoi1݁jB
*/

/**
index Ԗڂ̃f[^t@C烍[hBt@C FILENAME_PREFIX + index + FILENAME_POSTFIX
*/
LifeGameData::LifeGameData(int index, IShell* shell) {
    IFileMgr* filemgr;
    IFile*  file;
    BPPString filename(FILENAME_PREFIX);
    filename += BPPString::IntToString(index);
    filename += FILENAME_POSTFIX;
    ISHELL_CreateInstance(shell, AEECLSID_FILEMGR, (void**)&filemgr);
    file = IFILEMGR_OpenFile(filemgr, filename.GetBuffer(), _OFM_READ);

    char buffer[5000];
    IFILE_Read(file, buffer, sizeof(buffer) - 1);
    char* ps = buffer;
    char* pe = ps;
    while(*pe != '\t') pe++;
    name = BPPString(ps, pe - ps);
    pe++;
    ps = pe;
    while(*pe != '\t') pe++;
    BPPString tempStr(ps, pe - ps);
    int width = ATOI(tempStr.GetBuffer());
    pe++;
    ps = pe;
    while(*pe != '\t') pe++;
    tempStr = BPPString(ps, pe - ps);
    int height = ATOI(tempStr.GetBuffer());
    pe++;

    int count = 0;
    matrix.init(width + 2, height + 2);
    for (int i = 1 ; i < width + 1 ; i++) {
        for (int j = 1 ; j < height + 1 ; j++) {
            if (pe[count++] == '1') {
                matrix.setCell(i, j, 1);
            } else {
                matrix.setCell(i, j, 0);
            }
        }
    }
    IFILE_Release(file);
    IFILEMGR_Release(filemgr);
}

/**
 index Ԗڂ̃f[^t@CɏoBt@C FILENAME_PREFIX + index + FILENAME_POSTFIX
*/
void LifeGameData::write(int index, IShell* shell) {
    BPPString out = name;
    out += "\t";
    out += BPPString::IntToString(matrix.getWidth() - 2);
    out += "\t";
    out += BPPString::IntToString(matrix.getHeight() - 2);
    out += "\t";
    for(int i = 1 ; i < matrix.getWidth() - 1 ; i++){
        for (int j = 1 ; j < matrix.getHeight() -1 ; j++){
            out += ((matrix.getCell(i, j) == 1) ? "1" : "0");
        }
    }

    IFileMgr*  filemgr;
    IFile*  file;

    BPPString filename(FILENAME_PREFIX);
    filename += BPPString::IntToString(index);
    filename += FILENAME_POSTFIX;

    ISHELL_CreateInstance(shell, AEECLSID_FILEMGR, (void**)&filemgr);
    file = IFILEMGR_OpenFile(filemgr, filename.GetBuffer(), _OFM_READWRITE);
    if (file == NULL) {
        file = IFILEMGR_OpenFile(filemgr, filename.GetBuffer(), _OFM_CREATE);
    }
    IFILE_Write(file, out.GetBuffer(), out.GetLength());
    IFILE_Release(file);
    IFILEMGR_Release(filemgr);
}
