#ifndef __SAVEPANEL_HPP
#define __SAVEPANEL_HPP

#include "LifeGame.hpp"
#include "MemoryPanel.hpp"
#include "SoftKeyWindow.hpp"
#include "AEEText.h"

class SavePanel : public MemoryPanel {
private:
    ListBox* list;
    ITextCtl* textCtl;
    int cursor;
public:
    SavePanel(WindowManager* wm_);
    virtual ~SavePanel();
    virtual void paint();
    virtual void keyPress(uint16 key);
};

#endif //__SAVEPANEL_HPP
