#ifndef __SOFTKEYWINDOW_HPP
#define __SOFTKEYWINDOW_HPP

#include "LifeGameApp.hpp"
#include "BPPLib.hpp"

class SoftKeyWindow : public Window {
private:
    BPPString textLeft, textCenter, textRight;
    int width;
public:
    SoftKeyWindow(WindowManager* wm_, int width_);
    virtual void paint();
    void setText(const BPPString& textLeft_, const BPPString& textCenter_, const BPPString& textRight_);
    virtual void keyPress(uint16 /*key*/) {};
};

#endif //__SOFTKEYWINDOW_HPP
