#ifndef __CHANGESIZEPANEL_HPP
#define __CHANGESIZEPANEL_HPP

#include "LifeGame.hpp"
#include "SoftKeyWindow.hpp"

class ChangeSizePanel : public Window {
private: 
    ITextCtl* widthTextBox;
    ITextCtl* heightTextBox;
    const int space;
    const int fontHeight;
    int cursor;

public:
    ChangeSizePanel(WindowManager* wm_);
    virtual ~ChangeSizePanel();
    virtual void paint();
    virtual void keyPress(uint16 key);
};

#endif //__CHANGESIZEPANEL_HPP
